-- 1 --

drop function fn_srednia

create function fn_srednia(@rodzaj varchar(12)) returns int
begin
  return (select avg(price) from pubs..titles where type=@rodzaj)
end

select dbo.fn_srednia('business')


-- 2 --

CREATE FUNCTION Siedem ( @x INT = 7 ) RETURNS INT
BEGIN
   RETURN ( @x )
END

SELECT dbo.Siedem( DEFAULT )

-- 3 --

drop function fn_silnia

create function fn_silnia(@n int) returns decimal(38,0)
begin
  if ( @n<0 or @n>31 ) return 0
  if ( @n=0 or @n=0 ) return 1
  return @n*dbo.fn_silnia(@n-1)
end

select dbo.fn_silnia(31) [Silnia 3]


-- 4 --

drop function fn_tablicasilni

create function fn_tablicasilni(@ile int) returns @tablica table(liczba decimal(38,0))
begin
  if ( @ile>30 ) set @ile=30
  declare @i int
  set @i=1
  while ( @i<=@ile )
  begin
    insert into @tablica select dbo.fn_silnia(@i)
    set @i=@i+1
  end
  return
end

select * from fn_tablicasilni(40)


-- 5 --

drop function funkcja

create function funkcja(@max int) returns table
return (select * from liczby where liczba<=@max)

select * from funkcja(3)
